From b21f40ff24b49447fb477437a38c098194e01eb1 Mon Sep 17 00:00:00 2001
From: Alexey Min <alexey.min@gmail.com>
Date: Wed, 13 Jan 2021 22:08:44 +0300
Subject: [PATCH 37/59] AlpineApkUpdater: try harder to get error string from
 helper

---
 .../backends/AlpineApkBackend/AlpineApkUpdater.cpp | 14 ++++++++++++--
 1 file changed, 12 insertions(+), 2 deletions(-)

diff --git a/libdiscover/backends/AlpineApkBackend/AlpineApkUpdater.cpp b/libdiscover/backends/AlpineApkBackend/AlpineApkUpdater.cpp
index c03fd5c5c..677a784f8 100644
--- a/libdiscover/backends/AlpineApkBackend/AlpineApkUpdater.cpp
+++ b/libdiscover/backends/AlpineApkBackend/AlpineApkUpdater.cpp
@@ -299,12 +299,22 @@ void AlpineApkUpdater::handleKAuthHelperError(
         KAuth::ExecuteJob *reply,
         const QVariantMap &replyData)
 {
-    const QString message = replyData.value(QLatin1String("errorString"),
+    // error message should be received as part of JSON reply from helper
+    QString message = replyData.value(QLatin1String("errorString"),
                                             reply->errorString()).toString();
-    qCDebug(LOG_ALPINEAPK) << "KAuth helper returned error:" << message << reply->error();
     if (reply->error() == KAuth::ActionReply::Error::AuthorizationDeniedError) {
+        qCWarning(LOG_ALPINEAPK) << "updater: KAuth helper returned AuthorizationDeniedError";
         Q_EMIT passiveMessage(i18n("Authorization denied"));
     } else {
+        // if received error message is empty, try other ways to get error text for user
+        // there are multiple ways to get error messages in kauth/kjob
+        if (message.isEmpty()) {
+            message = reply->errorString();
+            if (message.isEmpty()) {
+                message = reply->errorText();
+            }
+        }
+        qCDebug(LOG_ALPINEAPK) << "updater: KAuth helper returned error:" << message << reply->error();
         Q_EMIT passiveMessage(i18n("Error") + QStringLiteral(":\n") + message);
     }
 }
-- 
GitLab


